---
title: "JABBA-SELECT beta"
author: "Henning Winker"
date: "Cape Town, 2019"
output: html_document


---
#### <i> Development repository for JABBA-Select that (will) be added under https://github.com/jabbamodel </i> pending publication.

<br />


<b> The Respority includes:

+ The JABBA-Select source code beta version `JABBA_SELECTv1.2beta.R`, which is called from an assessment specific "Prime" file.

+ A basic simulation example `JABBA_SELECT_prime_KOBsim.R`. New data can be generated from a stochastic age-structured simulation model from `asmsim2jabba_data.R`, which calls the function `OM_ccsra2jabba_Fn.R` that has been adopted from the R package [CCSRA](https://github.com/James-Thorson/CCSRA).

+ A complex worked example `JABBA_SELECT_prime_SWOss3.R` that replicates the Stock Synthesis (ss3) base-case scenario of the 2017 [ICCAT assessment of North Atlantic swordfish](https://www.iccat.int/Documents/Meetings/Docs/2017_ATL_SWO_ASS_REP_ENG.pdf) with JABBA-Select. The `JABBA_SELECT_prime_SWOss3.R` example illustrates how JABBA-Select can be set up for a sex-structured stock that is expoited by 11 fleets fishing with variations of logistic and dome-shaped selectivity pattern (n=6) and fitted to 9 CPUE time series of varying lengths with units    given either in weight or numbers. Additional code `ss2jabba_swnbase.R` is provided to demonstrate how JABBA-Select input data (catch by fleet, abudance indices, life history, selectivity functions) can be extracted from a SS3 .rep file (here readily compiled as swnbase.rdata object using the R package [r4ss](https://cran.r-project.org/web/packages/r4ss/])). 
 
</b>

### Getting started
JABBA requires the installation of [R](https://cran.r-project.org/) and [JAGS](https://sourceforge.net/projects/mcmc-jags/). 

Each JABBA-SELECT assessment requires an R `Prime` to read-in the input data from five comma-separated value files (.csv): (1) `catch`, (2) `cpue`, (3) `se`, (4) `select` and (5) `selex`; customize the stock-specific settings (e.g. Life History) and then execute the JABBA-Select source code. The R file `JABBA_SELECTv1.2beta.R` contains the source code of the most recent version, which is excuted via the `source()` function from a customized `Prime` file. 


<br />

**For further documentation also see:**

+ [Winker, H., Carvalho, F., Kapur, M. (2018) <U>JABBA: Just Another Bayesian Biomass Assessment.</U> *Fisheries Research* **204**: 275-288.](https://www.sciencedirect.com/science/article/pii/S0165783618300845)   
+ [JABBA beta](https://github.com/Henning-Winker/JABBAbeta) development respository for the JABBA model on github.  

<br />
<br />